#include <stdio.h>
#include <stdlib.h>

struct node {
  int val;
  struct node * next;  
};

void print(struct node *list) {
  while(list != 0) {
    printf("%d;", list->val);
    list = list->next;
  }
  printf("\n");
}

struct node *back(struct node *list) {
  while(list != 0) {
    if(list->next == 0) return list;
    list = list->next;
  }
  return 0;
}

void push_back(struct node **list, int val) {
  struct node **back = list;
  while(*back != 0)
    back = &(*back)->next;
  *back = malloc(sizeof(struct node));
  (*back)->val = val;
  (*back)->next = 0;
}

void push_front(struct node **list, int val) {
  struct node *next = malloc(sizeof(struct node));
  next->val = val;
  next->next = (*list);
  (*list) = next;
}

void pop_front(struct node **list) {
  if(*list == 0) return;
  struct node *del = *list;
  (*list) = (*list)->next;
  free(del);
}

void pop_back(struct node **list) {
  if(*list == 0) return;
  struct node **back = list;
  while((*back)->next != 0)
    back = &(*back)->next;
  struct node *del = *back;
  (*back) = 0;
  free(del);
}

int main() {
  typedef struct node * list;
  list lst = 0;
  print(lst);

  push_back(&lst, 11);
  print(lst);

  push_back(&lst, 12);
  print(lst);

  push_back(&lst, 13);
  print(lst);  
  printf("back: %d\n", back(lst)->val);

  push_front(&lst, 10);
  print(lst);  
  
  pop_front(&lst);
  print(lst);

  pop_back(&lst);
  print(lst);
  
  pop_back(&lst);
  print(lst);

  pop_front(&lst);
  print(lst);
}
