#ifndef SCHEDULER_H
#define SCHEDULER_H

#include <queue>
#include "Task.h"

class Scheduler {
 public:
  void push(Task * t);
  void action();
  static Scheduler & instance();
  bool empty() const { return _tasks.empty(); }
  void run() { while(!empty()) action(); }
 private:
  Scheduler();
  ~Scheduler();
  static Scheduler * _instance;
  std::priority_queue<Task *, std::vector<Task *>, CompareTasks> _tasks;
};

#endif
