#include "Buffer.h"

Buffer::Buffer(unsigned int maxSize) : _maxSize(maxSize), _size(0) {
}

Buffer::~Buffer() {
}

bool Buffer::push(unsigned int data) {
  if(data + _size > _maxSize) return false;
  _queue.push(data);
  _size += data;
  return true;
}

unsigned int Buffer::pop() {
  if(empty()) return 0;
  unsigned int data = _queue.front();
  _queue.pop();
  _size -= data;
  return data;
}

bool Buffer::fits(unsigned int data) {
  return data + _size <= _maxSize;
}

unsigned int Buffer::topData() {
  if(empty()) return 0;
  else return _queue.front();
}


