#include "Detector.h"
#include "Scheduler.h"
#include "EventBuffering.h"
#include "EventBuilding.h"
#include "EventBuilder.h"
#include "Random.h"
#include <iostream>
#include <algorithm>

Detector::Detector(double tau, double m1, double m2, double m3, double s1, double s2, double s3,
		   Buffer & b1, Buffer & b2, Buffer & b3, EventBuilder & b) : _tau(tau),
					_m1(m1), _m2(m2), _m3(m3), _s1(s1), _s2(s2), _s3(s3),
					_b1(&b1), _b2(&b2), _b3(&b3), _b(&b) {
}

Detector::~Detector() {
}

double Detector::event(double now) {
  TRandom3 & rnd = Random::instance();
  double time = now + rnd.Exp(_tau);
  unsigned int d1 = (unsigned int) std::max(1.0, rnd.Gaus(_m1, _s1));
  unsigned int d2 = (unsigned int) std::max(1.0, rnd.Gaus(_m2, _s2));
  unsigned int d3 = (unsigned int) std::max(1.0, rnd.Gaus(_m3, _s3));
  Scheduler & sch = Scheduler::instance();
  std::cout << ">>> detector event; time: " << time << ", det. event; data: " << d1 << ", " << d2 << ", " << d3 << std::endl;
  sch.push(new EventBuffering(time, d1, d2, d3, *_b1, *_b2, *_b3, *_b));
  return time;
}
