#include "EventBuffering.h"
#include "EventBuilding.h"
#include "EventBuilder.h"
#include "Buffer.h"
#include "Scheduler.h"
#include <iostream>

EventBuffering::EventBuffering(double time, unsigned int d1, unsigned int d2, unsigned int d3,
			       Buffer & b1, Buffer & b2, Buffer & b3, EventBuilder & b) :
  Task(time), _d1(d1), _d2(d2), _d3(d3), _b1(&b1), _b2(&b2), _b3(&b3), _b(&b), _time(time) {
}

EventBuffering::~EventBuffering() {
}

void EventBuffering::action() {
  bool ok1 = false, ok2 = false, ok3 = false;
  if((ok1 = _b1->push(_d1))) {
    if((ok2 = _b2->push(_d2))) {
      if(!(ok3 = _b3->push(_d3))) {
	_b1->pop();
	_b2->pop();
      }
    } else {
      _b1->pop();
    }
  }
  if(ok1 && ok2 && ok3) {
    std::cout << "time: " << time() << ", buffered " << _d1 << ", " << _d2 << ", " << _d3 << std::endl;
    if(_b->idle()) Scheduler::instance().push(new EventBuilding(_time, *_b));
  }
  else std::cout << "time: " << time() << ", *** data lost: " << _d1 << ", " << _d2 << ", " << _d3 << std::endl;
}
  
