#include "EventBuilding.h"
#include "EventBuilder.h"
#include "Scheduler.h"
#include <iostream>

EventBuilding::EventBuilding(double now, EventBuilder & b) : Task(now + b.daqTime()), _b(&b) {
  std::cout << ">>> schedule event building; time: " << now << " + daq time: " << b.daqTime() << " = " << time() << std::endl;
  _b->setBusy();
}

EventBuilding::~EventBuilding() {
}

void EventBuilding::action() {
  std::cout << "time: " << time() << ", event build" << std::endl;
  _b->build();
  if(!_b->idle()) {
    std::cout << ">>> buffer not empty; schedule next build" << std::endl;
    Scheduler::instance().push(new EventBuilding(time(), *_b));
  }
}
